{ **************************************************************** }
{ *                                                              * }
{ *   Modu: MODEM.PAS                                           * }
{ *   Autor: Sebastian STYBEL                                    * }
{ *   Adres: http://www.sebastian.stybel.prv.pl                  * }
{ *          sstybel@poczta.pnet.pl                     	 * }
{ *          sstybel@poczta.onet.pl                      	 * }
{ *          sstybel@zt.elblag.tpsa.pl                 		 * }
{ *   Opis : Modu obsugujacy modem                             * }
{ *                                                              * }
{ *                  Copyright (C) 1999, Elblg                  * }
{ *                                                              * }
{ **************************************************************** }

UNIT Modem;

{$G+}

INTERFACE

{ Definicja staych pomocniczych }

  CONST
    mdm_Port_szeregowy_COM1 = $01;
    mdm_Port_szeregowy_COM2 = $02;
    mdm_Port_szeregowy_COM3 = $03;
    mdm_Port_szeregowy_COM4 = $04;

  CONST
    mdm_Predkosc_transmisji_50bps     = 50;
    mdm_Predkosc_transmisji_75bps     = 75;
    mdm_Predkosc_transmisji_110bps    = 110;
    mdm_Predkosc_transmisji_150bps    = 150;
    mdm_Predkosc_transmisji_300bps    = 300;
    mdm_Predkosc_transmisji_600bps    = 600;
    mdm_Predkosc_transmisji_1200bps   = 1200;
    mdm_Predkosc_transmisji_1800bps   = 1800;
    mdm_Predkosc_transmisji_2000bps   = 2000;
    mdm_Predkosc_transmisji_2400bps   = 2400;
    mdm_Predkosc_transmisji_3600bps   = 3600;
    mdm_Predkosc_transmisji_4800bps   = 4800;
    mdm_Predkosc_transmisji_7200bps   = 7200;
    mdm_Predkosc_transmisji_9600bps   = 9600;
    mdm_Predkosc_transmisji_12000bps  = 12000;
    mdm_Predkosc_transmisji_14400bps  = 14400;
    mdm_Predkosc_transmisji_16800bps  = 16800;
    mdm_Predkosc_transmisji_19200bps  = 19200;
    mdm_Predkosc_transmisji_21600bps  = 21600;
    mdm_Predkosc_transmisji_24000bps  = 24000;
    mdm_Predkosc_transmisji_26400bps  = 26400;
    mdm_Predkosc_transmisji_28800bps  = 28800;
    mdm_Predkosc_transmisji_38400bps  = 38400;
    mdm_Predkosc_transmisji_57600bps  = 57600;
    mdm_Predkosc_transmisji_115200bps = 115200;

  CONST
    mdm_Dlugosc_slowa_5Bit = $00;
    mdm_Dlugosc_slowa_6Bit = $01;
    mdm_Dlugosc_slowa_7Bit = $02;
    mdm_Dlugosc_slowa_8Bit = $03;

  CONST
    mdm_Bit_parzystosci_NO   = $00;
    mdm_Bit_parzystosci_ODD  = $08;
    mdm_Bit_parzystosci_EVEN = $18;
    mdm_Bit_parzystosci_HIGH = $28;
    mdm_Bit_parzystosci_LOW  = $38;

  CONST
    mdm_Bit_stopu_1Bit = $00;
    mdm_Bit_stopu_2Bit = $04;

  CONST
    mdm_Wybieranie_tonowe    = True;
    mdm_Wybieranie_impulsowe = False;

  CONST
    mdm_Ton_kontrolny_brak   = $00;
    mdm_Ton_kontrolny_550Hz  = $01;
    mdm_Ton_kontrolny_1800Hz = $02;

  CONST
    mdm_Wlacz_echo  = True;
    mdm_Wylacz_echo = False;

  CONST
    mdm_Komunikacja_asynchroniczna  = $00;
    mdm_Komunikacja_synchroniczna_1 = $01;
    mdm_Komunikacja_synchroniczna_2 = $02;
    mdm_Komunikacja_synchroniczna_3 = $03;

  CONST
    mdm_Wlacz_wyswietlanie_komunikatow  = True;
    mdm_Wylacz_wyswietlanie_komunikatow = False;

  CONST
    mdm_Komunikaty_w_postaci_cyfrowej  = True;
    mdm_Komunikaty_w_postaci_tekstowej = False;

  CONST
    mdm_Rozszerzone_wyswietlanie_komunikatow_1 = $00;
    mdm_Rozszerzone_wyswietlanie_komunikatow_2 = $01;
    mdm_Rozszerzone_wyswietlanie_komunikatow_3 = $02;
    mdm_Rozszerzone_wyswietlanie_komunikatow_4 = $03;
    mdm_Rozszerzone_wyswietlanie_komunikatow_5 = $04;

  CONST
    mdm_Norma_transmisji_ITU_T = True;
    mdm_Norma_transmisji_BELL  = False;

  CONST
    mdm_Glosnosc_modemu_brak    = $00;
    mdm_Glosnosc_modemu_mala    = $01;
    mdm_Glosnosc_modemu_srednia = $02;
    mdm_Glosnosc_modemu_duza    = $03;

  CONST
    mdm_Podsluch_modemu_brak            = $00;
    mdm_Podsluch_modemu_przy_wybieraniu = $01;
    mdm_Podsluch_modemu_caly_czas       = $02;
    mdm_Podsluch_modemu_przy_laczeniu   = $03;

{ Definicja zmiennych }

  VAR
    mdm_Bit_stopu           : ShortInt;
    mdm_Adres_portu         : Integer;
    mdm_Przerwanie_portu    : ShortInt;
    mdm_Dlugosc_slowa       : ShortInt;
    mdm_Bit_parzystosci     : ShortInt;
    mdm_Predkosc_transmisji : LongInt;

{ Definicja procedur i funkcji }

  PROCEDURE Otworz_port(Port_COM : Byte; Predkosc : LongInt; Dlugosc, Parzystosc, Stop : Byte;
                        Rozmiar_bufora_wejscia, Rozmiar_bufora_wyjscia : Word);
  PROCEDURE Zamknij_port;
  PROCEDURE Zmien_predkosc_transmisji_portu(Predkosc : LongInt);
  PROCEDURE Zmien_parametry_transmisji_portu(Dlugosc, Parzystosc, Stop : Byte);
  PROCEDURE Ustaw_DTR(Stan : Boolean);
  PROCEDURE Ustaw_RTS(Stan : Boolean);
  PROCEDURE Ustaw_OUT1(Stan : Boolean);
  PROCEDURE Ustaw_OUT2(Stan : Boolean);
  FUNCTION Stan_DTR : Boolean;
  FUNCTION Stan_RTS : Boolean;
  FUNCTION Stan_OUT1 : Boolean;
  FUNCTION Stan_OUT2 : Boolean;
  FUNCTION Stan_CTS : Boolean;
  FUNCTION Stan_DSR : Boolean;
  FUNCTION Stan_RI : Boolean;
  FUNCTION Stan_DCD : Boolean;
  PROCEDURE Sprzetowa_kontrola_przeplywu(RTS, CTS : Boolean; RTSOn, RTSOff : Word);
  PROCEDURE Programowa_kontrola_przeplywu(XON_XOFF : Boolean; XON, XOFF : Char);
  PROCEDURE Rodzaj_kontroli_przeplywy(VAR RTS, CTS, XON_XOFF : Boolean);
  FUNCTION Odczytaj_dane_z_portu : Char;
  FUNCTION Odczytaj_ciag_danych_z_portu : STRING;
  PROCEDURE Wyslij_dane_do_portu(Dane : Char);
  PROCEDURE Wyslij_ciag_danych_do_portu(Ciag : STRING);
  PROCEDURE Czekaj_na_oproznienie_bufora_wyjsciowego;
  PROCEDURE Wyslij_z_opoznieniem_ciag_danych_do_portu(Ciag : STRING; Czas : Word);
  FUNCTION Czekaj_na_ciag_danych(Ciag : STRING; Czas : Byte; VAR Lancuch : STRING; Wyswietl : Boolean; X, Y : Byte) : Boolean;
  PROCEDURE Inicjuj_modem;
  PROCEDURE Reset_modemu;
  PROCEDURE Wyswietl_konfiguracje_modemu;
  PROCEDURE Norma_transmisji_modemu(Norma : Boolean);
  PROCEDURE Ton_kontrolny_modemu(Ton : Byte);
  PROCEDURE Echo_modemu(Czy_echo : Boolean);
  PROCEDURE Tryb_komunikacji_modemu(Tryb : Byte);
  PROCEDURE Komunikaty_modemu(Komunikat : Boolean);
  PROCEDURE Typ_komunikatow_modemu(Typ : Boolean);
  PROCEDURE Rozszerzone_komunikaty_modemu(Typ : Byte);
  PROCEDURE Glosnosc_modemu(Glos : Byte);
  PROCEDURE Podsluch_glosnika_modemu(Podsluch : Byte);
  PROCEDURE Przejscie_do_trybu_OFF_Line;
  PROCEDURE Przejscie_do_trybu_ON_Line;
  PROCEDURE Nawiaz_polaczenie(Numer : STRING; Jak_wykrecic : Boolean);
  PROCEDURE Odbiur_polaczenia;
  PROCEDURE Automatyczny_odbiur_polaczenia(Liczba_dzwonkow : Byte);
  PROCEDURE Rozlacz_polaczenie;

IMPLEMENTATION

{ Definicja moduw }

USES
  Crt, Dos, Port_COM;

{ Definicja staych pomocniczych }

CONST
  TRB = $0000;
  IER = $0001;
  IIR = $0002;
  FCR = $0002;
  LCR = $0003;
  MCR = $0004;
  LSR = $0005;
  MSR = $0006;
  SCR = $0007;

{ Definicja zmiennych pomocniczych }

VAR
  PIC                                : Word;
  Maska                              : Byte;
  Przerwanie_COM                     : Integer;
  RTS_ON, RTS_OFF                    : Word;
  Stare_przerwanie                   : Pointer;
  Znak_XON, Znak_XOFF                : Char;
  Dane_wejscia, Dane_wyjscia         : Word;
  Bufor_wejscia, Bufor_wyjscia       : Pointer;
  Rozmiar_wejscia, Rozmiar_wyjscia   : Word;
  Naglowek_wejscia, Naglowek_wyjscia : Word;
  Rejestr_statusu, Rejestr_kontrolny : Byte;

{ Definicja modemw }

PROCEDURE Przerwanie; INTERRUPT; ASSEMBLER;
ASM
	        PUSH	                AX
	        PUSH	                BX
	        PUSH	                CX
	        PUSH	                DX
	        PUSH	                SI
	        PUSH	                DI
	        PUSH	                DS
	        PUSH	                ES
	        PUSH	                BP
@1:
	        MOV	                DX, mdm_Adres_portu
	        ADD	                DL, IIR
	        IN	                AL, DX
	        TEST	                AL, 01H
	        JNZ                     @24
	        DEC	                DX
	        DEC	                DX
	        CMP	                AL, 00H
	        JZ	                @4
	        CMP	                AL, 02H
	        JZ	                @10
	        CMP	                AL, 04H
	        JNZ	                @2
	        JMP	                @13
@2:
                CMP	                AL, 06H
	        JZ	                @3
	        JMP	                @1
@3:
                ADD	                DL, LSR
	        IN	                AL, DX
	        SUB	                DL, LSR
	        ADD	                DL, IER
	        IN	                AL, DX
	        MOV	                AH, AL
	        AND	                AL, 0FDH
	        OUT	                DX, AL
	        MOV	                AL, AH
	        OUT	                DX, AL
	        JMP	                @1
@4:
                NOP
@5:
                ADD	                DL, MSR
	        IN	                AL, DX
	        SUB	                DL, MSR
	        MOV	                CL, Rejestr_statusu
	        MOV	                CH, Rejestr_kontrolny
	        TEST	                CH, 02H
	        JZ	                @7
	        TEST	                AL, 10H
	        JNZ	                @6
	        OR	                CL, 40H
	        JMP	                @7
@6:
                AND	                CL, 0BFH
@7:
                MOV	                Rejestr_statusu, CL
@8:
     	        ADD	                DL, IER
	        IN	                AL, DX
	        OR	                AL, 02H
	        TEST	                CL, 0C4H
	        JZ	                @9
	        AND	                AL, 0FDH
@9:
                OUT	                DX, AL
	        JMP	                @1
@10:
	        MOV	                AH, Rejestr_statusu
	        TEST	                AH, 04H
	        JNZ	                @12
	        MOV	                SI, Dane_wyjscia
	        MOV	                DI, Naglowek_wyjscia
	        INC	                SI
	        CMP	                SI, Rozmiar_wyjscia
	        JB	                @11
	        XOR	                SI, SI
@11:
                MOV	                Dane_wyjscia, SI
	        LES	                BX, Bufor_wyjscia
	        MOV	                AL, [ES:BX + SI]
	        OUT	                DX, AL
	        CMP	                DI, SI
	        JNZ	                @12
	        OR	                AH, 04H
@12:
                AND	                AH, 0D7H
	        MOV	                Rejestr_statusu, AH
	        JMP	                @5
@13:
                IN	                AL, DX
	        MOV	                CL, AL
	        MOV	                AL, Rejestr_statusu
	        MOV	                AH, Rejestr_kontrolny
	        TEST	                AH, 04H
	        JZ	                @16
	        CMP	                CL, Znak_XOFF
	        JZ	                @14
	        CMP	                CL, Znak_XON
	        JNZ	                @16
	        AND	                AL, 7FH
	        JMP	                @15
@14:
                OR	                AL, 80H
@15:
                MOV	                CL, AL
	        JMP	                @7
@16:
                TEST	                AH, 80H
	        JZ	                @17
@17:
                AND	                AL, 0FEH
	        TEST	                AL, 02H
	        JZ	                @18
	        OR	                AL, 10H
	        JMP	                @23
@18:
	        MOV	                DI, Naglowek_wejscia
	        MOV	                SI, Dane_wejscia
	        INC	                DI
	        CMP	                DI, Rozmiar_wejscia
	        JB	                @19
	        XOR	                DI, DI
@19:
	        MOV	                Naglowek_wejscia, DI
	        LES	                BX, Bufor_wejscia
	        MOV	                [ES:BX + DI], CL
	        CMP	                SI, DI
	        JNZ	                @20
	        OR	                AL, 02H
	        JMP	                @22
@20:
     	        CMP	                SI, DI
	        JBE	                @21
	        SUB	                SI, DI
	        MOV	                DI, Rozmiar_wejscia
@21:
                SUB	                DI, SI
	        CMP	                DI, RTS_OFF
	        JB	                @23
@22:
                TEST	                AH, 01H
	        JZ	                @23
	        MOV	                CH, AL
	        ADD	                DL, MCR
	        IN	                AL, DX
	        AND	                AL, 0FDH
	        OUT	                DX, AL
	        SUB	                DL, MCR
	        MOV	                AL, CH
@23:
                MOV	                Rejestr_statusu, AL
	        ADD	                DL, IER
	        IN	                AL, DX
	        MOV	                AH, AL
	        AND	                AL, 0FDH
	        OUT	                DX, AL
	        MOV	                AL, AH
	        OUT	                DX, AL
	        JMP	                @1
@24:
                CMP                     PIC, 20H
                JE                      @25
	        MOV	                AL, 62H
                MOV                     DX, 20H
	        OUT	                DX, AL
	        MOV	                AL, 20H
                MOV                     DX, 0A0H
	        OUT	                DX, AL
                JMP                     @26
@25:
	        MOV	                AL, 20H
                MOV                     DX, 20H
	        OUT	                DX, AL
@26:
	        POP	                BP
	        POP	                ES
	        POP	                DS
	        POP	                DI
	        POP	                SI
	        POP	                DX
	        POP	                CX
	        POP	                BX
	        POP	                AX
END;

PROCEDURE Inicjuj;
BEGIN
  Stare_przerwanie:=NIL;
  Bufor_wejscia:=NIL;
  Bufor_wyjscia:=NIL;
  Maska:=$00;
  PIC:=$0000;
  Rozmiar_wejscia:=$0000;
  Rozmiar_wyjscia:=$0000;
  Naglowek_wejscia:=$0000;
  Naglowek_wyjscia:=$0000;
  Dane_wejscia:=$0000;
  Dane_wyjscia:=$0000;
  RTS_ON:=$0000;
  RTS_OFF:=$0000;
  Znak_XON:=#00;
  Znak_XOFF:=#00;
  Rejestr_kontrolny:=$00;
  Rejestr_statusu:=$00;
  Przerwanie_COM:=-1;
  mdm_Predkosc_transmisji:=-1;
  mdm_Bit_parzystosci:=-1;
  mdm_Dlugosc_slowa:=-1;
  mdm_Bit_stopu:=-1;
  mdm_Adres_portu:=-1;
  mdm_Przerwanie_portu:=-1;
END;

PROCEDURE Otworz_port(Port_COM : Byte; Predkosc : LongInt; Dlugosc, Parzystosc, Stop : Byte;
                      Rozmiar_bufora_wejscia, Rozmiar_bufora_wyjscia : Word);

VAR
  N : Byte;

BEGIN
  mdm_Predkosc_transmisji:=-1;
  mdm_Bit_parzystosci:=-1;
  mdm_Dlugosc_slowa:=-1;
  mdm_Bit_stopu:=-1;
  mdm_Adres_portu:=Adres_portu(Port_COM);
  IF mdm_Adres_portu=-1 THEN Exit;
  Przerwanie_COM:=Numer_przerwania_portu(Port_COM);
  IF Przerwanie_COM=-1 THEN Exit;
  mdm_Przerwanie_portu:=Przerwanie_COM;
  IF Przerwanie_COM>7 THEN
  BEGIN
    PIC:=$00A0;
    Maska:=$01 SHL (Przerwanie_COM - $08);
    Przerwanie_COM:=Przerwanie_COM + $68;
  END
  ELSE
  BEGIN
    PIC:=$0020;
    Maska:=$01 SHL Przerwanie_COM;
    Przerwanie_COM:=Przerwanie_COM + $08;
  END;
  INLINE($9C/$FA);
  Port[mdm_Adres_portu + IER]:=$0D;
  Port[mdm_Adres_portu + MCR]:=$0B;
  N:=Port[mdm_Adres_portu + TRB] + Port[mdm_Adres_portu + LSR] + Port[mdm_Adres_portu + MSR] + Port[mdm_Adres_portu + IIR];
  GetIntVec(Przerwanie_COM, Stare_przerwanie);
  SetIntVec(Przerwanie_COM, @Przerwanie);
  Port[PIC + $0001]:=Port[PIC + $0001] AND (Maska XOR $FF);
  N:=Port[PIC + $0001];
  Port[PIC]:=$20;
  IF PIC=$A0 THEN Port[$20]:=$20;
  Rozmiar_wejscia:=Rozmiar_bufora_wejscia;
  Rozmiar_wyjscia:=Rozmiar_bufora_wyjscia;
  GetMem(Bufor_wejscia, Rozmiar_wejscia);
  GetMem(Bufor_wyjscia, Rozmiar_wyjscia);
  Naglowek_wejscia:=$0000;
  Naglowek_wyjscia:=$0000;
  Dane_wejscia:=$0000;
  Dane_wyjscia:=$0000;
  RTS_ON:=Rozmiar_wejscia - $0002;
  RTS_OFF:=Rozmiar_wejscia - $0001;
  Znak_XON:=#11;
  Znak_XOFF:=#13;
  Rejestr_kontrolny:=$00;
  Rejestr_statusu:=$05;
  mdm_Predkosc_transmisji:=Predkosc;
  mdm_Bit_parzystosci:=Parzystosc;
  mdm_Dlugosc_slowa:=Dlugosc;
  mdm_Bit_stopu:=Stop;
  INLINE($9D);
  Port[mdm_Adres_portu + LCR]:=Port[mdm_Adres_portu + LCR] OR $80;
  Port[mdm_Adres_portu + IER]:=Hi(115200 DIV Predkosc);
  Port[mdm_Adres_portu + TRB]:=Lo(115200 DIV Predkosc);
  Port[mdm_Adres_portu + LCR]:=Port[mdm_Adres_portu + LCR] AND NOT ($80);
  Port[mdm_Adres_portu + LCR]:=Dlugosc OR Parzystosc OR Stop;
END;

PROCEDURE Zamknij_port;

VAR
  N : Byte;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  INLINE($9C/$FA);
  Port[mdm_Adres_portu + MCR]:=$00;
  Port[mdm_Adres_portu + IER]:=$00;
  Port[PIC + $0001]:=Port[PIC + $0001] OR Maska;
  N:=Port[PIC + $0001];
  Port[PIC]:=$20;
  IF PIC=$A0 THEN Port[$20]:=$20;
  SetIntVec(Przerwanie_COM, Stare_przerwanie);
  N:=Port[mdm_Adres_portu + TRB] + Port[mdm_Adres_portu + LSR] + Port[mdm_Adres_portu + MSR] + Port[mdm_Adres_portu + IIR];
  FreeMem(Bufor_wejscia, Rozmiar_wejscia);
  FreeMem(Bufor_wyjscia, Rozmiar_wyjscia);
  Naglowek_wejscia:=$0000;
  Naglowek_wyjscia:=$0000;
  Dane_wejscia:=$0000;
  Dane_wyjscia:=$0000;
  Rozmiar_wejscia:=$0000;
  Rozmiar_wyjscia:=$0000;
  RTS_ON:=$0000;
  RTS_OFF:=$0000;
  Znak_XON:=#00;
  Znak_XOFF:=#00;
  Rejestr_kontrolny:=$00;
  Rejestr_statusu:=$00;
  Przerwanie_COM:=-1;
  mdm_Predkosc_transmisji:=-1;
  mdm_Bit_parzystosci:=-1;
  mdm_Dlugosc_slowa:=-1;
  mdm_Bit_stopu:=-1;
  mdm_Adres_portu:=-1;
  mdm_Przerwanie_portu:=-1;
  INLINE($9D);
END;

PROCEDURE Zmien_predkosc_transmisji_portu(Predkosc : LongInt);
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Port[mdm_Adres_portu + LCR]:=Port[mdm_Adres_portu + LCR] OR $80;
  Port[mdm_Adres_portu + IER]:=Hi(115200 DIV Predkosc);
  Port[mdm_Adres_portu + TRB]:=Lo(115200 DIV Predkosc);
  Port[mdm_Adres_portu + LCR]:=Port[mdm_Adres_portu + LCR] AND NOT ($80);
  mdm_Predkosc_transmisji:=Predkosc;
END;

PROCEDURE Zmien_parametry_transmisji_portu(Dlugosc, Parzystosc, Stop : Byte);
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Port[mdm_Adres_portu + LCR]:=Dlugosc OR Parzystosc OR Stop;
  mdm_Bit_parzystosci:=Parzystosc;
  mdm_Dlugosc_slowa:=Dlugosc;
  mdm_Bit_stopu:=Stop;
END;

PROCEDURE Ustaw_DTR(Stan : Boolean);

VAR
  Wartosc : Integer;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wartosc:=Port[mdm_Adres_portu + MCR];
  IF Stan THEN Wartosc:=Wartosc OR $0001 ELSE Wartosc:=Wartosc AND $00FE;
  Port[mdm_Adres_portu + MCR]:=Wartosc;
END;

PROCEDURE Ustaw_RTS(Stan : Boolean);

VAR
  Wartosc : Integer;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wartosc:=Port[mdm_Adres_portu + MCR];
  IF Stan THEN Wartosc:=Wartosc OR $0002 ELSE Wartosc:=Wartosc AND $00FD;
  Port[mdm_Adres_portu + MCR]:=Wartosc;
END;

PROCEDURE Ustaw_OUT1(Stan : Boolean);

VAR
  Wartosc : Integer;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wartosc:=Port[mdm_Adres_portu + MCR];
  IF Stan THEN Wartosc:=Wartosc OR $0004 ELSE Wartosc:=Wartosc AND $00FB;
  Port[mdm_Adres_portu+ MCR]:=Wartosc;
END;

PROCEDURE Ustaw_OUT2(Stan : Boolean);

VAR
  Wartosc : Integer;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wartosc:=Port[mdm_Adres_portu + MCR];
  IF Stan THEN Wartosc:=Wartosc OR $0008 ELSE Wartosc:=Wartosc AND $00F7;
  Port[mdm_Adres_portu+ MCR]:=Wartosc;
END;

FUNCTION Stan_DTR : Boolean;
BEGIN
  Stan_DTR:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_DTR:=(Port[mdm_Adres_portu + MCR] AND $0001)>$0000;
END;

FUNCTION Stan_RTS : Boolean;
BEGIN
  Stan_RTS:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_RTS:=(Port[mdm_Adres_portu + MCR] AND $0002)>$0000;
END;

FUNCTION Stan_OUT1 : Boolean;
BEGIN
  Stan_OUT1:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_OUT1:=(Port[mdm_Adres_portu + MCR] AND $0004)>$0000;
END;

FUNCTION Stan_OUT2 : Boolean;
BEGIN
  Stan_OUT2:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_OUT2:=(Port[mdm_Adres_portu + MCR] AND $0008)>$0000;
END;

FUNCTION Stan_CTS : Boolean;
BEGIN
  Stan_CTS:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_CTS:=(Port[mdm_Adres_portu + MSR] AND $0010)>$0000;
END;

FUNCTION Stan_DSR : Boolean;
BEGIN
  Stan_DSR:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_DSR:=(Port[mdm_Adres_portu + MSR] AND $0020)>$0000;
END;

FUNCTION Stan_RI : Boolean;
BEGIN
  Stan_RI:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_RI:=(Port[mdm_Adres_portu + MSR] AND $0040)>$0000;
END;

FUNCTION Stan_DCD : Boolean;
BEGIN
  Stan_DCD:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  Stan_DCD:=(Port[mdm_Adres_portu + MSR] AND $0080)>$0000;
END;

PROCEDURE Sprzetowa_kontrola_przeplywu(RTS, CTS : Boolean; RTSOn, RTSOff : Word);

VAR
  Wartosc : Byte;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wartosc:=Rejestr_kontrolny;
  IF RTS THEN Wartosc:=Wartosc OR $01 ELSE Wartosc:=Wartosc AND $FE;
  Rejestr_kontrolny:=Wartosc;
  IF RTS THEN
  BEGIN
    IF (RTSOff>=Rozmiar_wejscia) THEN RTSOff:=Rozmiar_wejscia - 1;
    IF (RTSOn>RTSOff) THEN RTSOff:=RTSOn;
    RTS_ON:=RTSOn;
    RTS_OFF:=RTSOff;
  END;
  Wartosc:=Rejestr_kontrolny;
  IF CTS THEN Wartosc:=Wartosc OR $02 ELSE Wartosc:=Wartosc AND $FD;
  Rejestr_kontrolny:=Wartosc;
END;

PROCEDURE Programowa_kontrola_przeplywu(XON_XOFF : Boolean; XON, XOFF : Char);

VAR
  Wartosc : Byte;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wartosc:=Rejestr_kontrolny;
  IF XON_XOFF THEN
  BEGIN
    Wartosc:=Wartosc OR $04;
    IF XON=XOFF THEN
    BEGIN
      XON:=#11;
      XOFF:=#13;
    END;
    IF XON>#32 THEN XON:=#11;
    IF XOFF>#32 THEN XOFF:=#13;
    Znak_XON:=XON;
    Znak_XOFF:=XOFF;
  END
  ELSE Wartosc:=Wartosc AND $FB;
  Rejestr_kontrolny:=Wartosc;
END;

PROCEDURE Rodzaj_kontroli_przeplywy(VAR RTS, CTS, XON_XOFF : Boolean);

VAR
  Wartosc : Byte;

BEGIN
  Wartosc:=Rejestr_kontrolny;
  IF (Wartosc AND $01)=$01 THEN RTS:=True ELSE RTS:=False;
  IF (Wartosc AND $02)=$02 THEN CTS:=True ELSE CTS:=False;
  IF (Wartosc AND $04)=$04 THEN XON_XOFF:=True ELSE XON_XOFF:=False;
END;

FUNCTION Odczytaj_dane_z_portu : Char; ASSEMBLER;
ASM
                XOR                     CH, CH
	        MOV	                DX, mdm_Adres_portu
                CMP                     DX, -1
	        JE                      @2
@1:
	        MOV	                AH, Rejestr_statusu
	        TEST	                AH, 01H
	        JNZ	                @1
	        CLI
                JMP                     @3
@2:
                MOV	                AL, CH
	        STI
	        JMP	                @7
@3:
	        MOV	                SI, Dane_wejscia
	        MOV	                DI, Naglowek_wejscia
	        INC	                SI
	        CMP	                SI, Rozmiar_wejscia
	        JB	                @4
	        XOR	                SI, SI
@4:
                MOV	                Dane_wejscia, SI
	        LES	                BX, Bufor_wejscia
	        MOV	                CH, [ES:BX + SI]
	        AND	                AH, 0EDH
	        CMP	                DI, SI
	        JNZ	                @5
	        OR	                AH, 01H
@5:
                MOV	                Rejestr_statusu, AH
	        CMP	                DI, SI
	        JAE	                @6
	        SUB	                SI, DI
	        MOV	                DI, Rozmiar_wejscia
@6:
                SUB	                DI, SI
	        CMP	                DI, RTS_ON
	        JA	                @2
	        MOV	                AL, Rejestr_kontrolny
	        TEST	                AL, 01H
	        JZ	                @2
	        ADD	                DL, MCR
	        IN	                AL, DX
	        OR	                AL, 02H
	        OUT	                DX, AL
	        JMP	                @2
@7:
                XOR                     AH, AH
END;

FUNCTION Odczytaj_ciag_danych_z_portu : STRING;

VAR
  I    : Word;
  Ciag : STRING;

BEGIN
  Odczytaj_ciag_danych_z_portu:='';
  IF mdm_Adres_portu=-1 THEN Exit;
  I:=$0000;
  Ciag:='';
  WHILE (Rejestr_statusu AND $01)<>$01 DO
  BEGIN
    Ciag:=Ciag + Odczytaj_dane_z_portu;
    Inc(I);
    IF I=$00FF THEN Break;
  END;
  Odczytaj_ciag_danych_z_portu:=Ciag;
END;

PROCEDURE Wyslij_dane_do_portu(Dane : Char); ASSEMBLER;
ASM
	        MOV	                DX, mdm_Adres_portu
                CMP                     DX, -1
	        JE                      @6
	        MOV	                CH, Dane
@1:
	        MOV	                AH, Rejestr_statusu
                TEST                    AH, 28H
                JNZ                     @1
	        CLI
	        TEST	                AH, 08H
	        JZ	                @2
	        OR	                AH, 20H
	        JMP	                @5
@2:
	        MOV	                DI, Naglowek_wyjscia
	        MOV	                SI, Dane_wyjscia
	        INC	                DI
	        CMP	                DI, Rozmiar_wyjscia
	        JB	                @3
	        XOR	                DI, DI
@3:
                MOV	                Naglowek_wyjscia, DI
	        LES	                BX, Bufor_wyjscia
	        MOV	                [ES:BX + DI], CH
	        CMP	                DI, SI
	        JNZ	                @4
	        OR	                AH, 08H
@4:
	        TEST	                AH, 0C0H
	        JNZ	                @5
	        TEST	                AH, 04H
	        JZ	                @5
	        AND	                AH, 0FBH
	        ADD	                DL, IER
	        IN	                AL, DX
	        OR	                AL, 02H
	        OUT	                DX, AL
	        SUB	                DL, IER
@5:
                MOV	                Rejestr_statusu, AH
	        STI
@6:
END;

PROCEDURE Wyslij_ciag_danych_do_portu(Ciag : STRING);

VAR
  I : Byte;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  FOR I:=1 TO Length(Ciag) DO Wyslij_dane_do_portu(Ciag[I]);
END;

PROCEDURE Czekaj_na_oproznienie_bufora_wyjsciowego;

VAR
  OK : Boolean;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  REPEAT
    OK:=(Rejestr_statusu AND $04)=$04;
    OK:=OK AND ((Port[mdm_Adres_portu + IER] AND $02)=$00);
  UNTIL OK;
END;

PROCEDURE Wyslij_z_opoznieniem_ciag_danych_do_portu(Ciag : STRING; Czas : Word);

VAR
  I : Byte;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Czekaj_na_oproznienie_bufora_wyjsciowego;
  FOR I:=1 TO Length(Ciag) DO
  BEGIN
    Wyslij_dane_do_portu(Ciag[I]);
    Czekaj_na_oproznienie_bufora_wyjsciowego;
    Delay(Czas);
  END;
END;

FUNCTION Czekaj_na_ciag_danych(Ciag : STRING; Czas : Byte; VAR Lancuch : STRING; Wyswietl : Boolean; X, Y : Byte) : Boolean;

  FUNCTION Szukaj_lancucha(Lancuch_1, Lancuch_2 : STRING) : Boolean;

  VAR
    Ok      : Boolean;
    Pozycja : Byte;

  BEGIN
    Pozycja:=Pos(Lancuch_2, Lancuch_1);
    IF Pozycja=0 THEN Ok:=False ELSE Ok:=True;
    Szukaj_lancucha:=Ok;
  END;

VAR
  I              : Word;
  Dane           : STRING;
  G1, M1, S1     : Word;
  G2, M2, S2, P  : Word;
  Koniec, Wynik  : Boolean;
  Czas_1, Czas_2 : LongInt;

BEGIN
  Czekaj_na_ciag_danych:=False;
  IF mdm_Adres_portu=-1 THEN Exit;
  I:=$0000;
  Dane:='';
  Lancuch:='';
  Koniec:=False;
  Wynik:=False;
  GetTime(G1, M1, S1, P);
  Czas_1:=(((G1 * 60) + M1) * 60) + S1;
  REPEAT
    WHILE (Rejestr_statusu AND $01)<>$01 DO
    BEGIN
      Dane:=Dane + Odczytaj_dane_z_portu;
      Inc(I);
      IF I=$00FF THEN Break;
    END;
    IF Dane<>'' THEN
    BEGIN
      Lancuch:=Dane;
      IF Szukaj_lancucha(Dane, Ciag) THEN
      BEGIN
        Wynik:=True;
        Koniec:=True;
      END;
    END;
    GetTime(G2, M2, S2, P);
    Czas_2:=(((G2 * 60) + M2) * 60) + S2;
    IF Wyswietl THEN
    BEGIN
      GotoXY(X, Y);
      Write(Czas - (Czas_2 - Czas_1), ' Sek. '#08);
    END;
    IF (Czas_2 - Czas_1)>=Czas THEN
    BEGIN
      Koniec:=True;
    END;
    IF KeyPressed THEN
    BEGIN
      Koniec:=True;
      ReadKey;
    END;
  UNTIL Koniec;
  Czekaj_na_ciag_danych:=Wynik;
END;

PROCEDURE Inicjuj_modem;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('AT&F' + #13, 5);
END;

PROCEDURE Reset_modemu;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATZ' + #13, 5);
END;

PROCEDURE Wyswietl_konfiguracje_modemu;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('AT&V' + #13, 5);
END;

PROCEDURE Norma_transmisji_modemu(Norma : Boolean);
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Norma=mdm_Norma_transmisji_ITU_T THEN Wyslij_z_opoznieniem_ciag_danych_do_portu('ATB0' + #13, 5)
                                      ELSE Wyslij_z_opoznieniem_ciag_danych_do_portu('ATB1' + #13, 5);
END;

PROCEDURE Ton_kontrolny_modemu(Ton : Byte);

VAR
  Liczba : STRING;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Ton>2 THEN Ton:=2;
  Str(Ton, Liczba);
  Wyslij_z_opoznieniem_ciag_danych_do_portu('AT&G' + Liczba + #13, 5);
END;

PROCEDURE Echo_modemu(Czy_echo : Boolean);
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Czy_echo=mdm_Wlacz_echo THEN Wyslij_z_opoznieniem_ciag_danych_do_portu('ATE1' + #13, 5)
                             ELSE Wyslij_z_opoznieniem_ciag_danych_do_portu('ATE0' + #13, 5);
END;

PROCEDURE Tryb_komunikacji_modemu(Tryb : Byte);

VAR
  Liczba : STRING;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Tryb>3 THEN Tryb:=3;
  Str(Tryb, Liczba);
  Wyslij_z_opoznieniem_ciag_danych_do_portu('AT&M' + Liczba + #13, 5);
END;

PROCEDURE Komunikaty_modemu(Komunikat : Boolean);
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Komunikat=mdm_Wlacz_wyswietlanie_komunikatow THEN Wyslij_z_opoznieniem_ciag_danych_do_portu('ATQ0' + #13, 5)
                                                  ELSE Wyslij_z_opoznieniem_ciag_danych_do_portu('ATQ1' + #13, 5);
END;

PROCEDURE Typ_komunikatow_modemu(Typ : Boolean);
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Typ=mdm_Komunikaty_w_postaci_cyfrowej THEN Wyslij_z_opoznieniem_ciag_danych_do_portu('ATV0' + #13, 5)
                                           ELSE Wyslij_z_opoznieniem_ciag_danych_do_portu('ATV1' + #13, 5);
END;

PROCEDURE Rozszerzone_komunikaty_modemu(Typ : Byte);

VAR
  Liczba : STRING;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Typ>4 THEN Typ:=4;
  Str(Typ, Liczba);
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATX' + Liczba + #13, 5);
END;

PROCEDURE Glosnosc_modemu(Glos : Byte);

VAR
  Liczba : STRING;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Glos>3 THEN Glos:=3;
  Str(Glos, Liczba);
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATL' + Liczba + #13, 5);
END;

PROCEDURE Podsluch_glosnika_modemu(Podsluch : Byte);

VAR
  Liczba : STRING;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Podsluch>3 THEN Podsluch:=3;
  Str(Podsluch, Liczba);
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATM' + Liczba + #13, 5);
END;

PROCEDURE Przejscie_do_trybu_OFF_Line;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('~~~+++~~~', 5);
END;

PROCEDURE Przejscie_do_trybu_ON_Line;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATO0' + #13, 5);
END;

PROCEDURE Nawiaz_polaczenie(Numer : STRING; Jak_wykrecic : Boolean);

CONST
  Nr : ARRAY[1..19] OF Char = '0123456789,!Ww/@$- ';

VAR
  Ok   : Boolean;
  I, J : Byte;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  FOR I:=1 TO Length(Numer) DO
  BEGIN
    Ok:=False;
    FOR J:=1 TO 19 DO IF Numer[I]=Nr[J] THEN Ok:=True;
    IF Ok=False THEN Exit;
  END;
  IF Jak_wykrecic=mdm_Wybieranie_tonowe THEN Wyslij_z_opoznieniem_ciag_danych_do_portu('ATDT' + Numer + #13, 5)
                                        ELSE Wyslij_z_opoznieniem_ciag_danych_do_portu('ATDP' + Numer + #13, 5);
END;

PROCEDURE Odbiur_polaczenia;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATA' + #13, 5);
END;

PROCEDURE Automatyczny_odbiur_polaczenia(Liczba_dzwonkow : Byte);

VAR
  Liczba : STRING;

BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  IF Liczba_dzwonkow>5 THEN Liczba_dzwonkow:=5;
  Str(Liczba_dzwonkow, Liczba);
  Wyslij_z_opoznieniem_ciag_danych_do_portu('ATS0=' + Liczba + #13, 5);
END;

PROCEDURE Rozlacz_polaczenie;
BEGIN
  IF mdm_Adres_portu=-1 THEN Exit;
  Wyslij_z_opoznieniem_ciag_danych_do_portu('~~~+++~~~ATH0' + #13, 5);
END;

{ Koniec moduu }

BEGIN
  ASM
                  JMP                     @1
                  DB                      '-==- Modu: MODEM - Sebastian Stybel - Copyright (c) 1999 -==-'
  @1:
                  CALL                    [Inicjuj]
  END;
END.